#include "oaiaction.h"

#if defined(GSDL_USE_OBJECTSPACE)
#  include <ospace\std\map>
#elif defined(GSDL_USE_STL_H)
#  include <map.h>
#else
#  include <map>
#endif

typedef map<text_t, oaiaction *, lttext_t> oaiactionmap;

class oaidispatcher
{
 private:
  oaiactionmap actions;
  oaiconfig   *configuration;
 public:
  oaidispatcher();
  ~oaidispatcher();
  void setConfiguration(oaiconfig *configuration) { this->configuration = configuration; }
  void addAction(oaiaction *thisAction);
  void doAction(ostream &stream, recptproto *protocol, oaiargs &args);
};
